# -*- coding: utf-8 -*-

import Spr
from time import sleep
from threading import Thread



class Controller(Thread):
	#status
	ST_STOP,ST_RUN,ST_IDLE,ST_DISPOSE = range(4)
	
	def __init__(self):
		self.status = self.ST_STOP
		self.interval = 0.1
		Thread.__init__(self)
		self.setDaemon(True)

	def run(self):
		while( not self.status == self.ST_DISPOSE ):
			if (self.status == self.ST_RUN):
				self.loop()
			sleep(self.interval)
	
	def loop(self):
		pass
	
	def SetInterval(self,interval):
		self.interval = interval



from collections import namedtuple
HeadControlData = namedtuple("HeadControlData","priority target owner")

class HeadController(Controller):
	def __init__(self,headController):
		Controller.__init__(self)
		self.headController = headController
		self.targetList = []
		
		self.Enable()
		
	def loop(self):
		sorted(self.targetList)
	
	def AddTarget(targetData):
		HeadControlData

class MoveController(Controller):
	def __init__(self,soBase):
		Controller.__init__(self)
		self.destPos = None
		self.soBase = soBase
		self.Enable()
		
	def loop(self):
		K = 1.0
		D = 0.2
		
		#BodyControllerがやるところ。Thread化したい
		#PD制御
		distVelocity = ( self.destPos - self.soBase.GetFramePosition()) * K + (Spr.Vec3d() - self.soBase.GetVelocity()) * D 
		#移動方向制限
		distVelocity.y = 0
		if distVelocity.norm() > 2:
			norm = distVelocity.norm()
			distVelocity = Spr.Vec3d(distVelocity.x / norm * 2 , 0 , distVelocity.z /norm * 2 )
		self.soBase.SetVelocity(distVelocity)
		
		tmp =  (self.destPos - self.soBase.GetFramePosition())
		tmp.y = 0
		tmp = tmp.unit()
		rot = (self.soBase.GetOrientation()*Spr.Vec3d(0,0,1)).CrossR( tmp )
		
		#回転制限
		rm = 0.2
		if rot.norm() > rm:
			rot = Spr.Vec3d( rot.x / rot.norm() * rm , rot.y /rot.norm() * rm , rot.z /rot.norm() *rm )
		

		q = Spr.Quaterniond.Rot(rot)
		#q = Spr.Quaterniond.Rot(rot.norm()*0.05,Spr.Vec3d(0,1,0))
		
		self.soBase.SetOrientation(q *  self.soBase.GetOrientation() )
		
		#ALook(env)
		
		#if CStand(env):
		#	self.soBase.SetVelocity(Spr.Vec3d())
		#	APick(env)
	
	def MoveTo(self,dest):
		self.destPos = dest
	
	def Enable(self, enable = True):
		if not self.isAlive():
			self.start()
		
		if enable:
			self.status = self.ST_RUN
		else:
			self.status = self.ST_STOP
	
	def Dispose(self):
		self.status = self.ST_DISPOSE
