# -*- coding: utf-8 -*-

import Spr
import copy

from .Database import DatabaseItem,ValueSet


#LabbeledSolid
class LSolid:
	def __init__(self,phSoOrlSo,attr = DatabaseItem()):
		self.phSolid = None
		if type(phSoOrlSo) == LSolid:
			self.phSolid = phSoOrlSo.phSolid
		elif type(phSoOrlSo) == Spr.PHSolid:
			self.phSolid = phSoOrlSo
		else:
			assert(False)
		self.name = self.phSolid.GetName()
		self.SetAttrInstance(attr)
		self.attrBase = attr
		
	
	def __repr__(self):
		return "LSolid<"+ self.name + ">"
	
	def __deepcopy__(self,dict):
		clone = LSolid(self.phSolid,self.attrBase)
		clone.attr = copy.deepcopy(self.attr)
		return clone
	
	def SetAttrInstance(self,attr):
		instance = DatabaseItem()
		instance.parents += (attr,) 
		instance.name = "instance of " + attr.name
		self.attr = instance
	
	def GetAttr(self,key):
		if key in self.attr:
			val = self.attr[key]
			conf = 1.0
			if type(val) == ValueSet:
				val,conf = self.attr[key]
			
			if callable(val):
				return ValueSet(val(),conf)
			else:
				return ValueSet(val,conf)
		else:
			return ValueSet(None,0)
	
	def SetAttr(self,key,valueset):
			self.attr[key] = valueset
	
	def DelAttr(self,key):
		if key in self.attr:
			del self.attr[key]
	
	def EnumAttr(self):
		attrDict = {}
		attrDict.update(self.attr.ToDict())
		return attrDict
			
	#def EnumAttrKeys(self):
	#	self.attr.Keys()
			
	def Clone(self):
		#deepcopy
		return copy.deepcopy(self)
		
