# -*- coding: utf-8 -*-
#日本語UTF-8

import bpy

def register_properties():
#==============================================================
#Scene
#==============================================================
    bpy.types.Scene.spr_step_enabled = bpy.props.BoolProperty(
        name = "[spr]physics step enabled",
        description="[Spr]Check to enable physics step.",
        default=0)
    bpy.types.Scene.spr_sub_step = bpy.props.IntProperty(
        name = "[spr]physics sub step",
        description="[Spr]Physics sub step",
        min = 1,
        default = 1)
    bpy.types.Scene.spr_num_iteration = bpy.props.IntProperty(
        name = "[spr]Num Iteration default=15",
        description="[Spr]LCP Num Iteration. Default=15",
        min = 1,
        default = 15)
    bpy.types.Scene.spr_step_speed_factor = bpy.props.FloatProperty(
        name = "[spr]Step Speed Factor default=1",
        description="[Spr]Change Step Speed. 0~1 to Slow, 1~ to Fast",
        min = 0,
        default = 1)
    bpy.types.Scene.spr_throw_enabled = bpy.props.BoolProperty(
        name = "[spr]throw enabled",
        description="[Spr]Check to enable throwing objecs.(Set Velocity)",
        default=0)

##Save Key Frame -----------------------------------------------
    bpy.types.Scene.spr_record_keyframe = bpy.props.BoolProperty(
        name = "[spr]Enable Recording KeyFrame",
        description="[Spr]",
        default=0)
    bpy.types.Scene.spr_step_keyframe = bpy.props.BoolProperty(
        name = "[spr]Enable Steping KeyFrame",
        description="[Spr]",
        default=0)
    bpy.types.Scene.spr_use_unique_keyframe = bpy.props.BoolProperty(
        name = "[spr]Enable Using Unique KeyFrame",
        description="[Spr]",
        default=0)
    bpy.types.Scene.spr_unique_keyframe = bpy.props.IntProperty(
        name = "[spr]Unique Keyframe",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Scene.spr_record_every_n_steps = bpy.props.IntProperty(
        name = "[spr]Record Keyframe Every N Steps",
        description="[Spr]",
        min = 1,
        default = 1)


##Creature ---------------------------------------------------------
    bpy.types.Scene.spr_creature_enabled = bpy.props.BoolProperty(
        name = "[spr]creature enabled",
        description="[Spr]",
        default=0)

##IK -----------------------------------------------------------------
    bpy.types.Scene.spr_ik_engine_enabled = bpy.props.BoolProperty(
        name = "[spr]IK Engine enabled",
        description="[Spr]",
        default=0)
    bpy.types.Scene.spr_ik_iteration_num = bpy.props.IntProperty(
        name = "[spr]IK Iteration Num",
        description="[Spr]",
        min = 1,
        default = 1)

##Run Scripts -------------------------------------------------------
    bpy.types.Scene.spr_run_scripts_enabled = bpy.props.BoolProperty(
        name = "[spr]run scripts enabled",
        description="[Spr]",
        default=0)
        

#=====================================================================
#Material
#=====================================================================
    bpy.types.Material.spr_friction_static = bpy.props.FloatProperty(
        name = "[spr]static friction coefficient",
        description="[Spr]",
        min = 0,
        #max = 9999,
        default = 0.5)

#======================================================================
#Object
#======================================================================
##Solid -----------------------------------------------------------------
    bpy.types.Object.spr_solid_realtime_editing = bpy.props.BoolProperty(
        name = "[spr]solid real-time editing mode",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_physics_type = bpy.props.EnumProperty(
        name = "[spr]spr physics type",
        description="[Spr]",
        #items = [("value","name","description")]
        items = [("Static","Static","Static"),
            ("Dynamic","Dynamic","Dynamic")])
    bpy.types.Object.spr_shape_type = bpy.props.EnumProperty(
        name = "[spr]spr shape type",
        description="[Spr]",
        #items = [("value","name","description")]
        items = [("None","None","None"),
            ("Box","Box","Box"),
            ("Sphere","Sphere","Sphere"),
            ("Convex","Convex","Convex Mesh")])
    bpy.types.Object.spr_inertia_manual_setting_enabled = bpy.props.BoolProperty(
        name = "[spr]inertia manual setting",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_inertia_x = bpy.props.FloatProperty(
        name = "[spr]inertia x",
        description="[Spr]",
        min = 0.000001,
        default = 1)
    bpy.types.Object.spr_inertia_y = bpy.props.FloatProperty(
        name = "[spr]inertia y",
        description="[Spr]",
        min = 0.000001,
        default = 1)
    bpy.types.Object.spr_inertia_z = bpy.props.FloatProperty(
        name = "[spr]inertia z",
        description="[Spr]",
        min = 0.000001,
        default = 1)
    bpy.types.Object.spr_center_x = bpy.props.FloatProperty(
        name = "[spr]center x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_center_y = bpy.props.FloatProperty(
        name = "[spr]center x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_center_z = bpy.props.FloatProperty(
        name = "[spr]center x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_compound_child = bpy.props.BoolProperty(
        name = "[spr]set child object to compound solid (convex mesh only)",
        description="[Spr]",
        default=0)

##Solid Control ------------------------------------------------------------
    bpy.types.Object.spr_solid_info_enabled = bpy.props.BoolProperty(
        name = "[spr]Solid Info Enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_velocity_realtime_control_enabled = bpy.props.BoolProperty(
        name = "[spr]Solid Velocity Realtime Control enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_ang_velocity_realtime_control_enabled = bpy.props.BoolProperty(
        name = "[spr]Solid Angular Velocity Realtime Control enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_force_realtime_control_enabled = bpy.props.BoolProperty(
        name = "[spr]Solid Add Force Realtime Control enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_torque_realtime_control_enabled = bpy.props.BoolProperty(
        name = "[spr]Solid Add Torque Realtime Control enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_set_force_point  = bpy.props.BoolProperty(
        name = "[spr]Solid Set Force Point",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_velocity_local = bpy.props.BoolProperty(
        name = "[spr]Solid Velocity Local",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_ang_velocity_local = bpy.props.BoolProperty(
        name = "[spr]Solid Angular Velocity Local",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_force_local = bpy.props.BoolProperty(
        name = "[spr]Solid Add Force Local",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_torque_local = bpy.props.BoolProperty(
        name = "[spr]Solid Add Torque Local",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_solid_velocity_x = bpy.props.FloatProperty(
        name = "[spr]Solid Velocity X",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_velocity_y = bpy.props.FloatProperty(
        name = "[spr]Solid Velocity Y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_velocity_z = bpy.props.FloatProperty(
        name = "[spr]Solid Velocity Z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_angular_velocity_x = bpy.props.FloatProperty(
        name = "[spr]Solid Angular Velocity X",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_angular_velocity_y = bpy.props.FloatProperty(
        name = "[spr]Solid Angular Velocity Y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_angular_velocity_z = bpy.props.FloatProperty(
        name = "[spr]Solid Angular Velocity Z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_force_x = bpy.props.FloatProperty(
        name = "[spr]Solid Force X",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_force_y = bpy.props.FloatProperty(
        name = "[spr]Solid Force Y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_force_z = bpy.props.FloatProperty(
        name = "[spr]Solid Force Z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_force_point_x = bpy.props.FloatProperty(
        name = "[spr]Solid Force Point X",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_force_point_y = bpy.props.FloatProperty(
        name = "[spr]Solid Force Point Y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_force_point_z = bpy.props.FloatProperty(
        name = "[spr]Solid Force Point Z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_torque_x = bpy.props.FloatProperty(
        name = "[spr]Solid Torque X",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_torque_y = bpy.props.FloatProperty(
        name = "[spr]Solid Torque Y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_solid_torque_z = bpy.props.FloatProperty(
        name = "[spr]Solid Torque Z",
        description="[Spr]",
        default = 0)


##Joint -------------------------------------------------------------------
    bpy.types.Object.spr_joint_realtime_editing = bpy.props.BoolProperty(
        name = "[spr]Joint Realtime Editing",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_joint_type = bpy.props.EnumProperty(
        name = "[spr]spr joint type",
        #items = [("value","name","description")]
        items = [("None","None","None"),
            ("Ball","Ball","ball joint"),
            ("Hinge","Hinge","hinge joint"),
            ("Slider","Slider","slider joint"),
            ("Spring","Spring","spring")])
    bpy.types.Object.spr_joint_enabled = bpy.props.BoolProperty(
        name = "[spr]Joint Enabled",
        description="[Spr]",
        default=1)
    bpy.types.Object.spr_joint_target = bpy.props.StringProperty(
        name = "[spr]joint target",
        description="[Spr]",
        default = "")
    bpy.types.Object.spr_additional_joint = bpy.props.BoolProperty(
        name = "[spr]additional joint",
        description="[Spr]Set This Object as Additional Joint",
        default=0)
    bpy.types.Object.spr_joint_plug_handle = bpy.props.BoolProperty(
        name = "[spr]joint plug handle",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_joint_plug_pos_x = bpy.props.FloatProperty(
        name = "[spr]joint plug pos x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_plug_pos_y = bpy.props.FloatProperty(
        name = "[spr]joint plug pos y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_plug_pos_z = bpy.props.FloatProperty(
        name = "[spr]joint plug pos z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_plug_ori_w = bpy.props.FloatProperty(
        name = "[spr]joint plug ori w",
        description="[Spr]",
        default = 1)
    bpy.types.Object.spr_joint_plug_ori_x = bpy.props.FloatProperty(
        name = "[spr]joint plug ori x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_plug_ori_y = bpy.props.FloatProperty(
        name = "[spr]joint plug ori y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_plug_ori_z = bpy.props.FloatProperty(
        name = "[spr]joint plug ori z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_plug_offset_x = bpy.props.FloatProperty(
        name = "[spr]joint plug ori offset x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_plug_offset_y = bpy.props.FloatProperty(
        name = "[spr]joint plug ori offset y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_plug_offset_z = bpy.props.FloatProperty(
        name = "[spr]joint plug ori offset z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_socket_enabled = bpy.props.BoolProperty(
        name = "[spr]joint socket enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_joint_socket_handle = bpy.props.BoolProperty(
        name = "[spr]joint socket handle",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_joint_socket_pos_x = bpy.props.FloatProperty(
        name = "[spr]joint socket pos x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_socket_pos_y = bpy.props.FloatProperty(
        name = "[spr]joint socket pos y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_socket_pos_z = bpy.props.FloatProperty(
        name = "[spr]joint socket pos z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_socket_ori_w = bpy.props.FloatProperty(
        name = "[spr]joint socket ori w",
        description="[Spr]",
        default = 1)
    bpy.types.Object.spr_joint_socket_ori_x = bpy.props.FloatProperty(
        name = "[spr]joint socket ori x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_socket_ori_y = bpy.props.FloatProperty(
        name = "[spr]joint socket ori y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_socket_ori_z = bpy.props.FloatProperty(
        name = "[spr]joint socket ori z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_spring = bpy.props.FloatProperty(
        name = "[spr]spring",
        description="[Spr]",
        min = 0,
        #max = 9999,
        default = 0)
    bpy.types.Object.spr_spring_x = bpy.props.FloatProperty(
        name = "[spr]spring X",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_spring_y = bpy.props.FloatProperty(
        name = "[spr]spring Y",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_spring_z = bpy.props.FloatProperty(
        name = "[spr]spring Z",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_spring_ori = bpy.props.FloatProperty(
        name = "[spr]Spring Ori",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_damper = bpy.props.FloatProperty(
        name = "[spr]damper",
        description="[Spr]",
        min = 0,
        #max = 9999,
        default = 0)
    bpy.types.Object.spr_damper_x = bpy.props.FloatProperty(
        name = "[spr]damper X",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_damper_y = bpy.props.FloatProperty(
        name = "[spr]damper Y",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_damper_z = bpy.props.FloatProperty(
        name = "[spr]damper Z",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_damper_ori = bpy.props.FloatProperty(
        name = "[spr]Damper Ori",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_joint_collision = bpy.props.BoolProperty(
        name = "[spr]joint collision",
        description="[Spr]",
        default=1)

###Joint Limit
    bpy.types.Object.spr_limit_spring = bpy.props.FloatProperty(
        name = "[spr]Joint Limit Spring",
        description="[Spr]",
        min = 0,
        default = 10000)
    bpy.types.Object.spr_limit_damper = bpy.props.FloatProperty(
        name = "[spr]Joint Limit Damper",
        description="[Spr]",
        min = 0,
        default = 10000)
    bpy.types.Object.spr_limit_range_max = bpy.props.FloatProperty(
        name = "[spr]joint limit range Max",
        description="[Spr]",
        #min = 0,
        #max = 9999,
        default = 3e+39)
    bpy.types.Object.spr_limit_range_min = bpy.props.FloatProperty(
        name = "[spr]joint limit range min",
        description="[Spr]",
        #min = 0,
        #max = 9999,
        default = 3e+39)
    bpy.types.Object.spr_limit_swing_max = bpy.props.FloatProperty(
        name = "[spr]joint limit swing Max",
        description="[Spr]",
        #min = 0,
        #max = 9999,
        default = 3e+39)
    bpy.types.Object.spr_limit_swing_min = bpy.props.FloatProperty(
        name = "[spr]joint limit swing min",
        description="[Spr]",
        #min = 0,
        #max = 9999,
        default = 3e+39)
    bpy.types.Object.spr_limit_twist_max = bpy.props.FloatProperty(
        name = "[spr]joint limit twist Max",
        description="[Spr]",
        #min = 0,
        #max = 9999,
        default = 3e+39)
    bpy.types.Object.spr_limit_twist_min = bpy.props.FloatProperty(
        name = "[spr]joint limit twist min",
        description="[Spr]",
        #min = 0,
        #max = 9999,
        default = 3e+39)

###Elastic-Plastic
    bpy.types.Object.spr_second_damper = bpy.props.FloatProperty(
        name = "[spr]Joint Second Damper",
        description="[Spr]",
        min = 0.001,
        default = 1.0)
    bpy.types.Object.spr_second_damper_x = bpy.props.FloatProperty(
        name = "[spr]Ball Joint Second Damper x",
        description="[Spr]",
        min = 0.001,
        default = 1.0)
    bpy.types.Object.spr_second_damper_y = bpy.props.FloatProperty(
        name = "[spr]Joint Second Damper y",
        description="[Spr]",
        min = 0.001,
        default = 1.0)
    bpy.types.Object.spr_second_damper_z = bpy.props.FloatProperty(
        name = "[spr]Joint Second Damper z",
        description="[Spr]",
        min = 0.001,
        default = 1.0)
    bpy.types.Object.spr_yield_stress = bpy.props.FloatProperty(
        name = "[spr]joint yield stress",
        description="[Spr]",
        min = 0,
        default = 10**10)
    bpy.types.Object.spr_hardness_rate = bpy.props.FloatProperty(
        name = "[spr]joint hardness rate",
        description="[Spr]",
        min = 0.001,
        default = 1.0)

###Joint Control 
    bpy.types.Object.spr_joint_target_position = bpy.props.FloatProperty(
        name = "[spr]joint target position",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_target_position_x = bpy.props.FloatProperty(
        name = "[spr]joint target position x(deg)",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_target_position_y = bpy.props.FloatProperty(
        name = "[spr]joint target position y(deg)",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_target_position_z = bpy.props.FloatProperty(
        name = "[spr]joint target position z(deg)",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_target_velocity = bpy.props.FloatProperty(
        name = "[spr]joint target velocity",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_target_velocity_x = bpy.props.FloatProperty(
        name = "[spr]joint target velocity x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_target_velocity_y = bpy.props.FloatProperty(
        name = "[spr]joint target velocity y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_target_velocity_z = bpy.props.FloatProperty(
        name = "[spr]joint target velocity z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_offset_force = bpy.props.FloatProperty(
        name = "[spr]joint offset force",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_offset_force_x = bpy.props.FloatProperty(
        name = "[spr]joint offset force x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_offset_force_y = bpy.props.FloatProperty(
        name = "[spr]joint offset force y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_offset_force_z = bpy.props.FloatProperty(
        name = "[spr]joint offset force z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_joint_max_force = bpy.props.FloatProperty(
        name = "[spr]joint max force",
        description="[Spr]",
        default = 3e+39,
        min = 0)




##IKEndEffector -----------------------------------------------------------------
    bpy.types.Object.spr_ik_end_effector = bpy.props.BoolProperty(
        name = "[spr]Set IK EndEffector",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_ik_target_local_pos_x = bpy.props.FloatProperty(
        name = "[spr]IK target local position x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_ik_target_local_pos_y = bpy.props.FloatProperty(
        name = "[spr]IK target local position y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_ik_target_local_pos_z = bpy.props.FloatProperty(
        name = "[spr]IK target local position z",
        description="[Spr]",
        default = 0)

##IKActuator ------------------------------------------------------------------
    bpy.types.Object.spr_ik_enabled = bpy.props.BoolProperty(
        name = "[spr]IK enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_ik_bias = bpy.props.FloatProperty(
        name = "[spr]IK bias",
        description="[Spr]",
        min = 0.001,    #ゼロダメ
        #max = 9999,
        default = 1.0)

##IK Control --------------------------------------------------------------------
    bpy.types.Object.spr_ik_realtime_editing = bpy.props.BoolProperty(
        name = "[spr]IK Realtime Editing",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_ik_pos_control_enabled = bpy.props.BoolProperty(
        name = "[spr]IK Position Control enabled",
        description="[Spr]",
        default=1)
    bpy.types.Object.spr_ik_ori_control_enabled = bpy.props.BoolProperty(
        name = "[spr]IK Orientation Control enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_ik_target_object_enabled = bpy.props.BoolProperty(
        name = "[spr]IK Target Object enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_ik_target_object_name = bpy.props.StringProperty(
        name = "[spr]IK Target Object Name",
        description="[Spr]",
        default = "")
    bpy.types.Object.spr_ik_target_pos_x = bpy.props.FloatProperty(
        name = "[spr]IK target position x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_ik_target_pos_y = bpy.props.FloatProperty(
        name = "[spr]IK target position y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_ik_target_pos_z = bpy.props.FloatProperty(
        name = "[spr]IK target position z",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_ik_target_ori_x = bpy.props.FloatProperty(
        name = "[spr]IK target orientation x",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_ik_target_ori_y = bpy.props.FloatProperty(
        name = "[spr]IK target orientation y",
        description="[Spr]",
        default = 0)
    bpy.types.Object.spr_ik_target_ori_z = bpy.props.FloatProperty(
        name = "[spr]IK target orientation z",
        description="[Spr]",
        default = 0)


##Creature -------------------------------------------------------------------
    bpy.types.Object.spr_creature_body = bpy.props.BoolProperty(
        name = "[spr]creature body",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_creature_id = bpy.props.IntProperty(
        name = "[spr]creature ID",
        description="[Spr]",
        min = 0,
        default = 0)
    bpy.types.Object.spr_CRIKSolid_label = bpy.props.StringProperty(
        name = "[spr]CRIKSolid label",
        description="[Spr]",
        default = "None")
    bpy.types.Object.spr_CRIKJoint_label = bpy.props.StringProperty(
        name = "[spr]CRIKJoint label",
        description="[Spr]",
        default = "None")
    bpy.types.Object.spr_creature_core = bpy.props.BoolProperty(
        name = "[spr]creature core",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_creature_spring_ratio = bpy.props.FloatProperty(
        name = "[spr]creature spring ratio",
        description="[Spr]",
        min = 0,
        default = 1)
    bpy.types.Object.spr_creature_damper_ratio = bpy.props.FloatProperty(
        name = "[spr]creature damper ratio",
        description="[Spr]",
        min = 0,
        default = 1)
    bpy.types.Object.spr_creature_core = bpy.props.BoolProperty(
        name = "[spr]creature core",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_creature_view_angle_alt = bpy.props.FloatProperty(
        name = "[spr]creature view angle Alt",
        description="[Spr]",
        min = 0,
        max = 90,
        default = 45)
    bpy.types.Object.spr_creature_view_angle_az = bpy.props.FloatProperty(
        name = "[spr]creature view angle Az",
        description="[Spr]",
        min = 0,
        max = 90,
        default = 60)
    bpy.types.Object.spr_creature_visualize_enabled = bpy.props.BoolProperty(
        name = "[spr]creature visualization enabled",
        description="[Spr]",
        default=0)
    bpy.types.Object.spr_creature_rule_parameter_0 = bpy.props.FloatProperty(
        name = "[spr]creature rule parameter 0",
        description="[Spr]",
        default = 1)
    bpy.types.Object.spr_creature_rule_parameter_1 = bpy.props.FloatProperty(
        name = "[spr]creature rule parameter 1",
        description="[Spr]",
        default = 1)
    bpy.types.Object.spr_creature_rule_parameter_2 = bpy.props.FloatProperty(
        name = "[spr]creature rule parameter 2",
        description="[Spr]",
        default = 1)
    bpy.types.Object.spr_creature_rule_parameter_3 = bpy.props.FloatProperty(
        name = "[spr]creature rule parameter 3",
        description="[Spr]",
        default = 1)
    bpy.types.Object.spr_creature_rule_parameter_4 = bpy.props.FloatProperty(
        name = "[spr]creature rule parameter 4",
        description="[Spr]",
        default = 1)
    bpy.types.Object.spr_creature_rule_parameter_5 = bpy.props.FloatProperty(
        name = "[spr]creature rule parameter 5",
        description="[Spr]",
        default = 1)
    bpy.types.Object.spr_visualizer_scale_base = bpy.props.FloatProperty(
        name = "[spr]creature visualizer scale base",
        description="[Spr]",
        min = 0,
        default = 1)
    bpy.types.Object.spr_visualizer_scale_max = bpy.props.FloatProperty(
        name = "[spr]creature visualizer scale max(absolute)",
        description="[Spr]",
        min = 0,
        default = 5)
    bpy.types.Object.spr_visualizer_attv_scale_f = bpy.props.FloatProperty(
        name = "[spr]creature visualizer attv scale factor(default:3.0)",
        description="[Spr]",
        min = 0,
        default = 3)
    bpy.types.Object.spr_visualizer_attt_scale_f = bpy.props.FloatProperty(
        name = "[spr]creature visualizer attt scale factor(default:0.0001)",
        description="[Spr]",
        min = 0,
        default = 0.0001)
    bpy.types.Object.spr_creature_realtime_editing = bpy.props.BoolProperty(
        name = "[spr]creature real-time editing mode",
        description="[Spr]",
        default=0)

